// USER CODE BEGIN Includes 
#include "main.h"
#include "stm32f429i_discovery_lcd.h"
#include "main.h"
#include "stm32f4xx_hal.h"
#include <stdint.h>
#include <stdio.h>
#include "stm32f429i_discovery_ts.h"
#include "stm32f429i_discovery.h"
#include "arm_math.h"
// USER CODE END Includes 

// Private variables 
#define Pi 3.1416 
#define OrdenFiltro 30

struct Inputs_Usuario {
  int FrecuenciaCorte;
  int FrecuenciaMuestreo;
};

int Modo=0; // 0 si coma flotante, 1 si punto fijo

float h_float[OrdenFiltro+1];  // coeficientes filtro en coma flotante
int16_t h_int[OrdenFiltro+1]; // coeficientes filtro en punto fijo
int16_t ADC_DATA[OrdenFiltro+1]; // vector de valores ledos por el ADC
float SalidaDAC_float = 0; // valor de salida del DAC en coma flotante
volatile int SalidaDAC_int=0; // valor de salida del DAC en punto fijo
int32_t SalidaDAC_intTEMP = 0; // valor de salida del DAC en punto fijo antes de ajustar factor de escala


TS_StateTypeDef  ts; // variable necesaria para utilizar el display
/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
ADC_HandleTypeDef hadc1;

DAC_HandleTypeDef hdac;

TIM_HandleTypeDef htim6;

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_ADC1_Init(void);
static void MX_DAC_Init(void);
static void MX_TIM6_Init(int);

/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */


int CalculaTIM_ARR(int FrecMuest) {
	int TIM_ARR;
	TIM_ARR = (90000000/FrecMuest)-1;
	return TIM_ARR;
}

struct Inputs_Usuario pantalla(){
		struct Inputs_Usuario Inputs;
	
		BSP_SDRAM_Init();
		BSP_LCD_Init();//Inicializamos LCD
		BSP_TS_Init(240, 320);
	
		BSP_LCD_Init();
		BSP_LCD_LayerDefaultInit(1, SDRAM_DEVICE_ADDR);
		BSP_LCD_DisplayOn();
	
		//MENU PARA ELEGIR PUNTO FIJO O COMA FLOTANTE
		BSP_LCD_SelectLayer(1);
		BSP_LCD_Clear(LCD_COLOR_BLACK);
		BSP_LCD_DisplayStringAtLine(3,"Coma flotante");
		BSP_LCD_DisplayStringAtLine(8,"Punto fijo");
		
		int aux=1;
		Inputs.FrecuenciaCorte=3000;
		Inputs.FrecuenciaMuestreo=40000;
		ts.Y=0;
		while(aux==1){
			BSP_TS_GetState(&ts);
			if (ts.Y>10&&ts.Y<160){
				BSP_LCD_Clear(LCD_COLOR_WHITE);
				BSP_LCD_DisplayStringAt(10, 150, (uint8_t *)"Coma Flotante", LEFT_MODE);
				HAL_Delay(1500);
				aux=0;
				Modo=0; //indica al resto del cdigo que se desea filtrar en coma flotante
			}

			if (ts.Y>200){
				BSP_LCD_Clear(LCD_COLOR_WHITE);
				BSP_LCD_DisplayStringAt(10, 150, (uint8_t *)"Punto Fijo", LEFT_MODE);
				HAL_Delay(1500);
				aux=0;
				Modo=1; //indica al resto del cdigo que se desea filtrar en punto fijo
			}
		}
		
		//MENU PARA ELEGIR FRECUENCIA DE CORTE
		BSP_LCD_Clear(LCD_COLOR_BLACK);
		BSP_LCD_DisplayStringAt(0, 20, (uint8_t *)"F. Corte", LEFT_MODE);
		BSP_LCD_DisplayStringAt(180, 20, (uint8_t *)" > ", LEFT_MODE);
		BSP_LCD_DisplayStringAt(15, 200, (uint8_t *)"-10", LEFT_MODE);
		BSP_LCD_DisplayStringAt(155, 200, (uint8_t *)"+10", LEFT_MODE);
		BSP_LCD_DisplayStringAt(15, 240, (uint8_t *)"-100", LEFT_MODE);
		BSP_LCD_DisplayStringAt(155, 240, (uint8_t *)"+100", LEFT_MODE);
		BSP_LCD_DisplayStringAt(15, 280, (uint8_t *)"-1000", LEFT_MODE);
		BSP_LCD_DisplayStringAt(155, 280, (uint8_t *)"+1000", LEFT_MODE);
		
		char cadena[10];
		sprintf(cadena, "%d Hz", Inputs.FrecuenciaCorte);
		BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
		BSP_LCD_DisplayStringAt(60, 80, (uint8_t *)cadena, LEFT_MODE);		
		
		aux=1;
		while(aux==1){
				ts.X=0;
				ts.Y=0;			
				BSP_TS_GetState(&ts);
			
				BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
			
				if (ts.X>10&&ts.X<120&&ts.Y>170&&ts.Y<240){	
					if (Inputs.FrecuenciaCorte >10){
						Inputs.FrecuenciaCorte = Inputs.FrecuenciaCorte-10;
					}				
					sprintf(cadena, "%d Hz", Inputs.FrecuenciaCorte);
					BSP_LCD_SetTextColor(LCD_COLOR_BLACK);
					BSP_LCD_FillRect(60, 80,220,60);
					BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
					BSP_LCD_DisplayStringAt(60, 80, (uint8_t *)cadena, LEFT_MODE);			
					HAL_Delay(100);
				}
				if (ts.X>10&&ts.X<120&&ts.Y>240&&ts.Y<280){
					if (Inputs.FrecuenciaCorte >100){
						Inputs.FrecuenciaCorte = Inputs.FrecuenciaCorte-100;
					}
					sprintf(cadena, "%d Hz", Inputs.FrecuenciaCorte);
					BSP_LCD_SetTextColor(LCD_COLOR_BLACK);
					BSP_LCD_FillRect(60, 80,220,60);
					BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
					BSP_LCD_DisplayStringAt(60, 80, (uint8_t *)cadena, LEFT_MODE);				
					HAL_Delay(100);
				}
				if (ts.X>10&&ts.X<120&&ts.Y>280&&ts.Y<320){		
					if (Inputs.FrecuenciaCorte >1000){
						Inputs.FrecuenciaCorte = Inputs.FrecuenciaCorte-1000;
					}
					sprintf(cadena, "%d Hz", Inputs.FrecuenciaCorte);
					BSP_LCD_SetTextColor(LCD_COLOR_BLACK);
					BSP_LCD_FillRect(60, 80,220,60);
					BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
					BSP_LCD_DisplayStringAt(60, 80, (uint8_t *)cadena, LEFT_MODE);
					HAL_Delay(100);
				}
					
				if (ts.X>120&&ts.X<240&&ts.Y>170&&ts.Y<240){			
					if (Inputs.FrecuenciaCorte < 39990){
						Inputs.FrecuenciaCorte = Inputs.FrecuenciaCorte+10;
					}				
					sprintf(cadena, "%d Hz", Inputs.FrecuenciaCorte);
					BSP_LCD_SetTextColor(LCD_COLOR_BLACK);
					BSP_LCD_FillRect(60, 80,200,60);
					BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
					BSP_LCD_DisplayStringAt(60, 80, (uint8_t *)cadena, LEFT_MODE);						
					HAL_Delay(100);
				}
				if (ts.X>120&&ts.X<240&&ts.Y>240&&ts.Y<280){
					if (Inputs.FrecuenciaCorte < 39900){
						Inputs.FrecuenciaCorte = Inputs.FrecuenciaCorte+100;
					}				
					sprintf(cadena, "%d Hz", Inputs.FrecuenciaCorte);
					BSP_LCD_SetTextColor(LCD_COLOR_BLACK);
					BSP_LCD_FillRect(60, 80,200,60);
					BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
					BSP_LCD_DisplayStringAt(60, 80, (uint8_t *)cadena, LEFT_MODE);			
					HAL_Delay(100);
				}
				if (ts.X>120&&ts.X<240&&ts.Y>280&&ts.Y<320){
					if (Inputs.FrecuenciaCorte < 39000){
						Inputs.FrecuenciaCorte = Inputs.FrecuenciaCorte+1000;
					}				
					sprintf(cadena, "%d Hz", Inputs.FrecuenciaCorte);
					BSP_LCD_SetTextColor(LCD_COLOR_BLACK);
					BSP_LCD_FillRect(60, 80,200,60);
					BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
					BSP_LCD_DisplayStringAt(60, 80, (uint8_t *)cadena, LEFT_MODE);				
					HAL_Delay(100);
				}					
				if (ts.Y>5&&ts.Y<100&&ts.X>180){		
					HAL_Delay(100);
					BSP_LCD_Clear(LCD_COLOR_WHITE);
					HAL_Delay(500);
					aux=0;
				}		
			HAL_Delay(150);
		}	

		HAL_Delay(150);
		
		//MENU PARA ELEGIR FRECUENCIA DE MUESTREO
		BSP_LCD_Clear(LCD_COLOR_BLACK);
		BSP_LCD_DisplayStringAt(0, 20, (uint8_t *)"F.Muestreo", LEFT_MODE);
		BSP_LCD_DisplayStringAt(180, 20, (uint8_t *)" > ", LEFT_MODE);
		BSP_LCD_DisplayStringAt(15, 200, (uint8_t *)"-10", LEFT_MODE);
		BSP_LCD_DisplayStringAt(155, 200, (uint8_t *)"+10", LEFT_MODE);
		BSP_LCD_DisplayStringAt(15, 240, (uint8_t *)"-100", LEFT_MODE);
		BSP_LCD_DisplayStringAt(155, 240, (uint8_t *)"+100", LEFT_MODE);
		BSP_LCD_DisplayStringAt(15, 280, (uint8_t *)"-1000", LEFT_MODE);
		BSP_LCD_DisplayStringAt(155, 280, (uint8_t *)"+1000", LEFT_MODE);
				
		sprintf(cadena, "%d Hz", Inputs.FrecuenciaMuestreo);
		BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
		BSP_LCD_DisplayStringAt(60, 80, (uint8_t *)cadena, LEFT_MODE);		
		
		aux = 1;
		while(aux==1){
				ts.X=0;
				ts.Y=0;			
				BSP_TS_GetState(&ts);			
				BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
			
				if (ts.X>10&&ts.X<120&&ts.Y>170&&ts.Y<240){	
					if (Inputs.FrecuenciaMuestreo >10){
						Inputs.FrecuenciaMuestreo = Inputs.FrecuenciaMuestreo-10;
					}				
					sprintf(cadena, "%d Hz", Inputs.FrecuenciaMuestreo);
					BSP_LCD_SetTextColor(LCD_COLOR_BLACK);
					BSP_LCD_FillRect(60, 80,220,60);
					BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
					BSP_LCD_DisplayStringAt(60, 80, (uint8_t *)cadena, LEFT_MODE);			
					HAL_Delay(100);
				}
				if (ts.X>10&&ts.X<120&&ts.Y>240&&ts.Y<280){
					if (Inputs.FrecuenciaMuestreo >100){
						Inputs.FrecuenciaMuestreo = Inputs.FrecuenciaMuestreo-100;
					}
					sprintf(cadena, "%d Hz", Inputs.FrecuenciaMuestreo);
					BSP_LCD_SetTextColor(LCD_COLOR_BLACK);
					BSP_LCD_FillRect(60, 80,220,60);
					BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
					BSP_LCD_DisplayStringAt(60, 80, (uint8_t *)cadena, LEFT_MODE);				
					HAL_Delay(100);
				}
				if (ts.X>10&&ts.X<120&&ts.Y>280&&ts.Y<320){		
					if (Inputs.FrecuenciaMuestreo >1000){
						Inputs.FrecuenciaMuestreo = Inputs.FrecuenciaMuestreo-1000;
					}
					sprintf(cadena, "%d Hz", Inputs.FrecuenciaMuestreo);
					BSP_LCD_SetTextColor(LCD_COLOR_BLACK);
					BSP_LCD_FillRect(60, 80,220,60);
					BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
					BSP_LCD_DisplayStringAt(60, 80, (uint8_t *)cadena, LEFT_MODE);
					HAL_Delay(100);
				}					
				if (ts.X>120&&ts.X<240&&ts.Y>170&&ts.Y<240){			
					if (Inputs.FrecuenciaMuestreo < 39990){
						Inputs.FrecuenciaMuestreo = Inputs.FrecuenciaMuestreo+10;
					}				
					sprintf(cadena, "%d Hz", Inputs.FrecuenciaMuestreo);
					BSP_LCD_SetTextColor(LCD_COLOR_BLACK);
					BSP_LCD_FillRect(60, 80,200,60);
					BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
					BSP_LCD_DisplayStringAt(60, 80, (uint8_t *)cadena, LEFT_MODE);						
					HAL_Delay(100);
				}
				if (ts.X>120&&ts.X<240&&ts.Y>240&&ts.Y<280){
					if (Inputs.FrecuenciaMuestreo < 39900){
						Inputs.FrecuenciaMuestreo = Inputs.FrecuenciaMuestreo+100;
					}				
					sprintf(cadena, "%d Hz", Inputs.FrecuenciaMuestreo);
					BSP_LCD_SetTextColor(LCD_COLOR_BLACK);
					BSP_LCD_FillRect(60, 80,200,60);
					BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
					BSP_LCD_DisplayStringAt(60, 80, (uint8_t *)cadena, LEFT_MODE);			
					HAL_Delay(100);
				}
				if (ts.X>120&&ts.X<240&&ts.Y>280&&ts.Y<320){
					if (Inputs.FrecuenciaMuestreo < 39000){
						Inputs.FrecuenciaMuestreo = Inputs.FrecuenciaMuestreo+1000;
					}				
					sprintf(cadena, "%d Hz", Inputs.FrecuenciaMuestreo);
					BSP_LCD_SetTextColor(LCD_COLOR_BLACK);
					BSP_LCD_FillRect(60, 80,200,60);
					BSP_LCD_SetTextColor(LCD_COLOR_BLUE);
					BSP_LCD_DisplayStringAt(60, 80, (uint8_t *)cadena, LEFT_MODE);				
					HAL_Delay(100);
				}					
				if (ts.Y>5&&ts.Y<100){			
					HAL_Delay(100);
					BSP_LCD_Clear(LCD_COLOR_WHITE);
					BSP_LCD_DisplayStringAt(40, 150, (uint8_t *)"Filtrando", LEFT_MODE);
					HAL_Delay(500);
					aux=0;
				}		
			HAL_Delay(150);
		}	
return Inputs;
}
void CalculaCoeficientes(struct Inputs_Usuario Inputs){
	float h_float_temp[OrdenFiltro+1];
	float Wc;
	int n=0;
	
	Wc = (2*Pi*Inputs.FrecuenciaCorte)/Inputs.FrecuenciaMuestreo;	
	
	//calculo de los coeficientes del filtro en coma flotante
	for (n=0; n<=OrdenFiltro; n++){
		h_float[n]=((float)sin(Wc*(n-OrdenFiltro/2)))/(Pi*(n-OrdenFiltro/2));
	}
	//calculo del coeficiente central del filtro en coma flotante
	if (OrdenFiltro % 2 == 0){
			h_float[OrdenFiltro/2] = Wc/Pi;
	}
	
	//calculo de los coeficientes del filtro en punto fijo
	for (n=0; n<=OrdenFiltro; n++){
		h_float_temp[n]=(h_float[n])*131072; // Ddesplazar 17 posiciones en binario 2^17 = 131072 
	}
	
	for (n=0;n<=OrdenFiltro;n++){  // h_int contiene los valores del filtro para punto fijo
		h_int[n] = (int16_t)h_float_temp[n];
	}
}

void HAL_TIM_PeriodElapsedCallback(TIM_HandleTypeDef *htim){
	if (Modo==0){
		
		SalidaDAC_float = 0;
		for (int i=0; i<=OrdenFiltro; i++){
			SalidaDAC_float += ADC_DATA[i]*h_float[OrdenFiltro+1-i];
		}
				
		for (int i=0;i<=OrdenFiltro-1;i++){
			ADC_DATA[i] = ADC_DATA[i+1];
		}
	
		HAL_ADC_Start(&hadc1);
		HAL_ADC_PollForConversion(&hadc1,100);
		ADC_DATA[OrdenFiltro] = HAL_ADC_GetValue(&hadc1);

		HAL_DAC_Start(&hdac, DAC_CHANNEL_2);
		HAL_DAC_SetValue(&hdac, DAC_CHANNEL_2, DAC_ALIGN_12B_R, SalidaDAC_float);
	}
		
	if (Modo==1){		
		
		SalidaDAC_intTEMP = 0;
		for (int i=0; i<=OrdenFiltro; i++){
			SalidaDAC_intTEMP += ((int16_t)(ADC_DATA[i])*(int16_t)h_int[OrdenFiltro+1-i]);
		}
		
		SalidaDAC_int = (int32_t)(SalidaDAC_intTEMP>>17);
				
		for (int i=0;i<=OrdenFiltro-1;i++){
			ADC_DATA[i] = ADC_DATA[i+1];
		}
	
		HAL_ADC_Start(&hadc1);
		HAL_ADC_PollForConversion(&hadc1,100);
		ADC_DATA[OrdenFiltro] = HAL_ADC_GetValue(&hadc1);
		
		HAL_DAC_Start(&hdac, DAC_CHANNEL_2);
		HAL_DAC_SetValue(&hdac, DAC_CHANNEL_2, DAC_ALIGN_12B_R, SalidaDAC_int);
	}
}

/* USER CODE END 0 */


int main(void)
{
	HAL_Init();
	SystemClock_Config();
	
	int TIM_ARR;
	struct Inputs_Usuario Inputs;
	
	Inputs = pantalla(); 
	CalculaCoeficientes(Inputs);
	TIM_ARR = CalculaTIM_ARR(Inputs.FrecuenciaMuestreo);
	
	MX_GPIO_Init();
	MX_ADC1_Init();
	MX_DAC_Init();
	MX_TIM6_Init(TIM_ARR);

	// "HAL_TIM_Base_Start_IT(&htim6)" inicia las interrupciones del Timer 6
	//	Tras ejecutar esta lnea, se ejecuta la funcin "HAL_TIM_PeriodElapsedCallback" peridicamente
	HAL_TIM_Base_Start_IT(&htim6); 
  while (1)
  {
		
  }
}


void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage 
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 8;
  RCC_OscInitStruct.PLL.PLLN = 360;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 4;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Activate the Over-Drive mode 
  */
  if (HAL_PWREx_EnableOverDrive() != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV4;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV2;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_5) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief ADC1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_ADC1_Init(void)
{

  /* USER CODE BEGIN ADC1_Init 0 */

  /* USER CODE END ADC1_Init 0 */

  ADC_ChannelConfTypeDef sConfig = {0};

  /* USER CODE BEGIN ADC1_Init 1 */

  /* USER CODE END ADC1_Init 1 */
  /** Configure the global features of the ADC (Clock, Resolution, Data Alignment and number of conversion) 
  */
  hadc1.Instance = ADC1;
  hadc1.Init.ClockPrescaler = ADC_CLOCK_SYNC_PCLK_DIV4;
  hadc1.Init.Resolution = ADC_RESOLUTION_12B;
  hadc1.Init.ScanConvMode = DISABLE;
  hadc1.Init.ContinuousConvMode = DISABLE;
  hadc1.Init.DiscontinuousConvMode = DISABLE;
  hadc1.Init.ExternalTrigConvEdge = ADC_EXTERNALTRIGCONVEDGE_NONE;
  hadc1.Init.ExternalTrigConv = ADC_SOFTWARE_START;
  hadc1.Init.DataAlign = ADC_DATAALIGN_RIGHT;
  hadc1.Init.NbrOfConversion = 1;
  hadc1.Init.DMAContinuousRequests = DISABLE;
  hadc1.Init.EOCSelection = ADC_EOC_SINGLE_CONV;
  if (HAL_ADC_Init(&hadc1) != HAL_OK)
  {
    Error_Handler();
  }
  /** Configure for the selected ADC regular channel its corresponding rank in the sequencer and its sample time. 
  */
  sConfig.Channel = ADC_CHANNEL_3;
  sConfig.Rank = 1;
  sConfig.SamplingTime = ADC_SAMPLETIME_3CYCLES;
  if (HAL_ADC_ConfigChannel(&hadc1, &sConfig) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN ADC1_Init 2 */

  /* USER CODE END ADC1_Init 2 */

}

/**
  * @brief DAC Initialization Function
  * @param None
  * @retval None
  */
static void MX_DAC_Init(void)
{

  /* USER CODE BEGIN DAC_Init 0 */

  /* USER CODE END DAC_Init 0 */

  DAC_ChannelConfTypeDef sConfig = {0};

  /* USER CODE BEGIN DAC_Init 1 */

  /* USER CODE END DAC_Init 1 */
  /** DAC Initialization 
  */
  hdac.Instance = DAC;
  if (HAL_DAC_Init(&hdac) != HAL_OK)
  {
    Error_Handler();
  }
  /** DAC channel OUT1 config 
  */
  sConfig.DAC_Trigger = DAC_TRIGGER_NONE;
  sConfig.DAC_OutputBuffer = DAC_OUTPUTBUFFER_ENABLE;
  if (HAL_DAC_ConfigChannel(&hdac, &sConfig, DAC_CHANNEL_1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN DAC_Init 2 */

  /* USER CODE END DAC_Init 2 */

}

 
static void MX_TIM6_Init(int TIM_ARR)
{

  /* USER CODE BEGIN TIM6_Init 0 */

  /* USER CODE END TIM6_Init 0 */

  TIM_MasterConfigTypeDef sMasterConfig = {0};

  /* USER CODE BEGIN TIM6_Init 1 */

  /* USER CODE END TIM6_Init 1 */
  htim6.Instance = TIM6;
  htim6.Init.Prescaler = 0;
  htim6.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim6.Init.Period = TIM_ARR; // TIM_ARR depende de la frec. de muestreo 
  htim6.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_DISABLE;
  if (HAL_TIM_Base_Init(&htim6) != HAL_OK)
  {
    Error_Handler();
  }
  sMasterConfig.MasterOutputTrigger = TIM_TRGO_ENABLE;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim6, &sMasterConfig) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM6_Init 2 */

  /* USER CODE END TIM6_Init 2 */

}


/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOH_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
